﻿open System
open System.Threading
open System.Threading.Tasks

let printUntilCanceled (message:string , timeout) =
    async
        {
            while true do
                Console.WriteLine(message )
                do! Async.Sleep(timeout)
        }

let onCanceled (ex:OperationCanceledException) =
    Console.WriteLine "Canceled!"

let cancelOneWorkflow(message,timeout) =

    let workAsync = printUntilCanceled(message, timeout)
    let canCancelAsync = Async.TryCancelled(workAsync, onCanceled)
    Console.WriteLine "Press any key to cancel"
    Async.Start canCancelAsync
    Console.ReadKey() |> ignore
    Async.CancelDefaultToken()

let cancelManyWorkflows() =

    let cancelationSource = new CancellationTokenSource()

    Console.WriteLine "Press any key to cancel"

    //let asyncs = 
//        [("Hello my baby", 700) ; ("Hello my honey", 900) ; ("Hello my ragtime gal", 1100)]    
//        |> List.map printUntilCanceled
//        |> List.map (fun workAsync -> (workAsync, onCanceled))
//        |> List.map Async.TryCancelled
//        |> Async.Parallel

    [("Hello my baby", 700) ; ("Hello my honey", 900) ; ("Hello my ragtime gal", 1100)]    
    |> List.map printUntilCanceled
    |> List.map (fun workAsync -> Async.TryCancelled(workAsync, onCanceled))
    //|> List.map (fun foo-> (foo, cancelationSource.Token))
    |> List.iter (fun foo -> Async.Start(foo, cancelationSource.Token))
   
    Console.ReadKey() |> ignore
    Console.WriteLine()
    
    cancelationSource.Cancel()

[<EntryPoint>]
let main argv = 

    //cancelOneWorkflow ("Waiting to cancel ...", 1000)
    cancelManyWorkflows()

    Console.WriteLine "Finished"
    Console.ReadKey() |> ignore

    0 // return an integer exit code
