﻿Imports System
Imports System.Collections.Generic
Imports System.Threading
Imports System.Threading.Tasks

Module Module1

    Async Function cancelOneTask(message As String, timeout As Integer, cancelationSource As CancellationTokenSource) As Task

        Await Task.Factory.StartNew(Sub()
                                        While Not cancelationSource.IsCancellationRequested
                                            Console.WriteLine(message)
                                            Thread.Sleep(timeout)
                                            If message.Contains("He's dead") Then
                                                Throw New InvalidOperationException(message)
                                            End If
                                        End While
                                    End Sub, cancelationSource.Token)

        Console.WriteLine("Canceled!")
    End Function

    Async Sub cancelManyTasks(cancelationSource As CancellationTokenSource)

        Dim tasks() As Task =
        {
            cancelOneTask("Hello my baby", 700, cancelationSource), _
            cancelOneTask("Hello my honey", 900, cancelationSource), _
            cancelOneTask("Hello my ragtime gal", 1100, cancelationSource)
        }

        Await Task.WhenAll(Tasks)

    End Sub

    Async Sub handleManyExceptions(cancelationSource As CancellationTokenSource)

        Dim tasks() As Task =
        {
            cancelOneTask("He's dead, Jim", 5000, cancelationSource), _
            cancelOneTask("He's alive, Spock", 5000, cancelationSource), _
            cancelOneTask("He's dead, Scotty", 5000, cancelationSource)
        }

        Try
            Await Task.WhenAll(Tasks)
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

    End Sub

    Sub Main()

        Dim cancelationSource = New CancellationTokenSource()

        Console.WriteLine("Press any key to cancel")

        cancelOneTask("Waiting for cancelation", 1000, cancelationSource)
        'cancelManyTasks(cancelationSource)
        'handleManyExceptions(cancelationSource)

        Console.ReadKey()
        cancelationSource.Cancel()

        Console.WriteLine()
        Console.WriteLine("Finished!")
        Console.ReadKey()

    End Sub

End Module
