﻿open System
open System.Net
open System.Threading.Tasks
open Microsoft.FSharp.Collections

let _webSites =
    [|
        ("Google", "http://google.com");
        ("Microsoft", "http://microsoft.com");
        ("Bennett Adelson", "http://www.bennettadelson.com/");
        ("Amazon", "http://www.amazon.com/");
        ("Facebook", "http://www.facebook.com/")
    |]

let getWebContentLengths() =
    Parallel.For( 0, _webSites.Length, 
        fun(index) ->
            let siteName, siteURL = _webSites.[index]
            let webClient = new WebClient()
            let htmlContent = webClient.DownloadString(siteURL)
            Console.WriteLine("{0} has {1} characters", siteName, htmlContent.Length)
        )

let sumWebContentLengths() =
    let sumLengths = 
        _webSites
        |> PSeq.map (fun (_, siteURL) ->
            let webClient = new WebClient()
            webClient.DownloadString(siteURL).Length)
        |> PSeq.sum
    Console.WriteLine("The sum of the site lengths is {0}", sumLengths)

[<EntryPoint>]
let main argv = 

    Console.WriteLine("ParallelFSharp") |> ignore
                    
    getWebContentLengths() |> ignore
    Console.WriteLine() |> ignore
    sumWebContentLengths()

    Console.WriteLine("Press any key to exit")
    Console.ReadKey() |> ignore

    0 // return an integer exit code
