﻿Imports System
Imports System.Linq.pa
Imports System.Net
Imports System.Threading.Tasks

Module Module1

    Dim _webSites As Tuple(Of String, String)() =
        {
            New Tuple(Of String, String)("Google", "http://google.com"),
            New Tuple(Of String, String)("Microsoft", "http://microsoft.com"),
            New Tuple(Of String, String)("Bennett Adelson", "http://www.bennettadelson.com/"),
            New Tuple(Of String, String)("Amazon", "http://www.amazon.com/"),
            New Tuple(Of String, String)("Facebook", "http://www.facebook.com/")
        }


    Sub getWebContentLengths()
        Parallel.For(0, _webSites.Length,
            Sub(index)
                Dim siteInfo = _webSites(index)
                Dim webClient = New WebClient()
                Dim htmlContent = webClient.DownloadString(siteInfo.Item2)
                Console.WriteLine("{0} has {1} characters", siteInfo.Item1,
                                                htmlContent.Length)
            End Sub)
    End Sub


    Sub sumWebContentLengths()
        Dim sumLengths =
            _webSites.AsParallel().Select(
                    Function(siteInfo)
                        Dim webClient = New WebClient()
                        Dim htmlContent = webClient.DownloadString(siteInfo.Item2)
                        Return htmlContent.Length
                    End Function
        ).Sum()
        Console.WriteLine("The sum of the site lengths is {0}", sumLengths)
    End Sub

    Sub Main()

        Console.WriteLine("ParallelVB")

        getWebContentLengths()
        Console.WriteLine()
        sumWebContentLengths()

        Console.WriteLine("Press any key to exit ...")
        Console.ReadKey()
    End Sub

End Module
